#include <string.h>

#include <extdll.h>
#include <sdk_util.h>
#include <dllapi.h>
#include <meta_api.h>

#include "demo_status.h"
#include "makehashstr.h"

//
inline BOOL IsValidPlayer(edict_t* pPlayer) {
	return(	(pPlayer) && 
		(!pPlayer->free) && 
		(GET_PRIVATE(pPlayer)) && 
		(!FNullEnt(pPlayer)) && 
		(GETPLAYERUSERID(pPlayer) > 0) && 
		(!FStrEq(STRING(pPlayer->v.netname),"")) ? TRUE : FALSE);
}

//
void PrintDemoStatus(edict_t *pThis) {
	CLIENT_PRINTF(pThis, print_console, UTIL_VarArgs("Demo Status %s\n", VVERSION));
	CLIENT_PRINTF(pThis, print_console, UTIL_VarArgs("  Server: '%s' [%s]\n", CVAR_GET_STRING("hostname"), MakeHashStr(CVAR_GET_STRING("demo_status_key"), CVAR_GET_STRING("hostname"))));
	CLIENT_PRINTF(pThis, print_console, UTIL_VarArgs("  Date/Time: %s\n", getdatetimestr(0)));
	
	CLIENT_PRINTF(pThis, print_console, UTIL_VarArgs("%4s %10s %16s %34s %34s\n",
		"id", "userid", "uniqueid", "hash", "name"));
	
	for(int i = 1; i <= gpGlobals->maxClients; i++) {
		edict_t * pPlayer = INDEXENT2(i);
		
		if(!IsValidPlayer(pPlayer))
			continue;
		
		CLIENT_PRINTF(pThis, print_console, UTIL_VarArgs(
			"%4i %10i %16s %34s %34s\n", 
			i, 
			GETPLAYERUSERID(pPlayer), 
			(*g_engfuncs.pfnGetPlayerAuthId)(pPlayer), 
			MakeHashStr(CVAR_GET_STRING("demo_status_key"), (*g_engfuncs.pfnGetPlayerAuthId)(pPlayer)),
			STRING(pPlayer->v.netname)
		));
	}
}

//"demo_status" on server
void ServerPrintDemoStatus(void) {
	SERVER_PRINT(UTIL_VarArgs("Demo Status %s\n", VVERSION));
	SERVER_PRINT(UTIL_VarArgs("  Server: '%s' [%s]\n", CVAR_GET_STRING("hostname"), MakeHashStr(CVAR_GET_STRING("demo_status_key"), CVAR_GET_STRING("hostname"))));
	SERVER_PRINT(UTIL_VarArgs("  Date/Time: %s\n", getdatetimestr(0)));
	
	SERVER_PRINT(UTIL_VarArgs("%4s %10s %16s %34s %34s\n",
		"id", "userid", "uniqueid", "hash", "name"));
	
	for(int i = 1; i <= gpGlobals->maxClients; i++) {
		edict_t * pPlayer = INDEXENT2(i);
		
		if(!IsValidPlayer(pPlayer))
			continue;
		
		SERVER_PRINT(UTIL_VarArgs(
			"%4i %10i %16s %34s %34s\n", 
			i, 
			GETPLAYERUSERID(pPlayer), 
			(*g_engfuncs.pfnGetPlayerAuthId)(pPlayer), 
			MakeHashStr(CVAR_GET_STRING("demo_status_key"), (*g_engfuncs.pfnGetPlayerAuthId)(pPlayer)),
			STRING(pPlayer->v.netname)
		));
	}
}

//"demo_status_all" server cmd
void CmdPrintDemoAll(void) {
	for(int i = 1; i <= gpGlobals->maxClients; i++) {
		edict_t * pPlayer = INDEXENT2(i);
			
		if(FNullEnt(pPlayer) || pPlayer->free)
			continue;
		
		PrintDemoStatus(pPlayer);
	}
	
	SERVER_PRINT(UTIL_VarArgs("[%s] Demo Status sent to all clients.", VLOGTAG));
}

/**************************************************************
* 
* Handle commands
*
**************************************************************/
static void ClientCommand(edict_t *pThis)
{
	int id;
	if(!(id = ENTINDEX2(pThis)))
		RETURN_META(MRES_IGNORED);
	
	const char *pcmd = CMD_ARGV(0);
	
	if(!strcasecmp(pcmd,"demo_status"))
	{
		PrintDemoStatus(pThis);
		
		RETURN_META(MRES_SUPERCEDE);
	}
		
	RETURN_META(MRES_IGNORED);
}


/*************************************************************
*
**************************************************************
*
* Register DLLAPI Hooks
*
**************************************************************
*
**************************************************************/
int __GetEntityAPI2( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion )
{
	if(!pFunctionTable) {
		return(FALSE);
	}
	else if(*interfaceVersion != INTERFACE_VERSION) {
		*interfaceVersion = INTERFACE_VERSION;
		return(FALSE);
	}
	
	memset( pFunctionTable, 0, sizeof( DLL_FUNCTIONS ) );
	
	pFunctionTable->pfnClientCommand         = ClientCommand;
	
	return(TRUE);
}
